	TITLE EXPORT.ASM

.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\comctl32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\comctl32.lib

IDD_MAINDLG                    equ  110
IDC_EDIT            equ             1000
IDM_OPEN         equ               40001
IDM_EXIT     equ                   40003

ExportDlgProc proto :DWORD,:DWORD,:DWORD,:DWORD

	; ==========
	; = MACROS =
	; ==========

	NTSIGNATURE MACRO pF
; Devuelve en eax el contenido del campo signatura.
; Pasar como parmetro el puntero a la vista proyectada.
	mov eax,pF
	movzx ebx,word ptr [eax+03Ch] ; eax = offset de la signatura
	add eax,ebx
	movzx eax,word ptr [eax]
	ENDM

	PEFHDROFFSET MACRO pF
; Devuelve en eax un puntero al encabezado PE
; Pasar como parmetro el puntero a la vista proyectada.
	mov eax, pF
	add eax, dword ptr [eax+03Ch] ; eax = offset de la signatura
	add eax, 4                    ; eax = offset del inicio del encabezado PE
	ENDM

	OPTHDROFFSET MACRO pF
; Devuelve en eax un puntero al encabezado opcional PE
; Pasar como parmetro el puntero a la vista proyectada.
        PEFHDROFFSET pF ; devuelve eax = offset del inicio del encabezado PE
	add eax, SIZEOF IMAGE_FILE_HEADER
	ENDM

	SECHDROFFSET MACRO pF
; Devuelve en eax un puntero a la tabla de secciones secciones
; Pasar como parmetro el puntero a la vista proyectada.
        OPTHDROFFSET pF ; devuelve eax = offset del inicio del encabezado op.
	add eax, SIZEOF IMAGE_OPTIONAL_HEADER 
	ENDM

; ==========================================================================

	.data?
hMod	 dd ?
@pFl	 dd ?
_maped   dd ?
buffer	 db 256 dup (?)
FileName db 256 dup (?) 
ofn	 OPENFILENAME <>

	.data
Col30	db 'RVA', 0
Col20	db 'Ord.', 0
Col10	db 'Nombre', 0

CapStr	db "Visor de funciones exportadas", 0
NoExportTable	db "No hay funciones que exportar", 0
Msg100	db "No se pudo abrir el archivo", 0
Msg101  db "Fallo al intentar cargar el archivo en este proceso.", 10, 13
	db "Se intentar proyectarla en memoria", 0
Msg102  db "Fallo al intentar abrir y proyectar el archivo.", 0

Filter	db "Archivos ejecutables (*.exe, *.dll, *.ocx)", 0
	db "*.exe; *.dll; *.ocx", 0
	db "Todos los archivos (*.*)", 0, "*.*", 0, 0

template1	db	"%u", 0
template2	db	"%lX", 0
template3	db	"Visor de funciones importadas - %s", 0

	.code
start:
	invoke	GetModuleHandle,NULL
	mov	hMod, eax
	invoke	DialogBoxParam, eax, IDD_MAINDLG,NULL,addr ExportDlgProc, 0
	invoke	ExitProcess, 0
	invoke  InitCommonControls

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ExportDlgProc proc hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD		
	.if uMsg==WM_INITDIALOG
; ----------------------------------
; Llenar la estructura OPENFILENAME
; ----------------------------------
		mov	ofn.lStructSize, SIZEOF ofn
		push	hDlg
		pop	ofn.hwndOwner
		push	hMod
		pop	ofn.hInstance
		mov	ofn.Flags, OFN_EXPLORER or OFN_LONGNAMES or OFN_HIDEREADONLY
		mov	ofn.lpstrTitle, 0
		mov	ofn.nMaxFile, 256
		mov	ofn.lpstrFile, offset FileName
		mov	ofn.lpstrFilter, offset Filter
		push	offset ofn
		call	GetOpenFileName
		or	eax, eax
		je	quit1

		mov	_maped, 0

		push	offset FileName
		call	LoadLibrary
		or	eax, eax
		jne	_loaded

		invoke	MessageBox, hDlg, addr Msg101, addr CapStr, MB_ICONWARNING

		inc	_maped
		push	offset FileName
		call	OpenAndMapFile
		or	eax, eax
		jne	_loaded

		invoke	MessageBox, hDlg, addr Msg102, addr CapStr, MB_ICONWARNING
		jmp	quit

_loaded:	mov	@pFl, eax
		push	eax

		push	0
		push	hDlg
		call	RefreshListview

		push	104
		push	hDlg
		call	ShowTheFunctionsName
		or	eax, eax
		je	quit

		push	offset FileName
		push	hDlg
		call	SetWindowText

	.elseif uMsg==WM_CLOSE
quit:		.if _maped==0
			invoke FreeLibrary, @pFl
		.else
			invoke UnmapViewOfFile, @pFl
		.endif
quit1:		invoke EndDialog, hDlg, 0

	.elseif uMsg==WM_COMMAND
		mov	eax, wParam
		.if ax==IDM_EXIT
			jmp	quit
		.endif

	.else
		mov eax, FALSE
		ret
	.endif
	mov eax, TRUE
	ret
ExportDlgProc endp	

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

RefreshListview	proc	uses esi ebx hDlg:DWORD, Param:DWORD
; -------------------------------------------------------------------------
local lvcolumn:LV_COLUMN, lvitem:LV_ITEM, hListView:DWORD
; -------------------------------------------------------------------------
	mov	ebx, hDlg
; -----------------------------
; Limpiar el control list view
; -----------------------------
	invoke	SendDlgItemMessage, ebx, 103, LVM_DELETEALLITEMS, 0, 0
; -------------------------------------------
; Obtener el manejador del control listview
; -------------------------------------------
	invoke	GetDlgItem, ebx, 104
	mov	hListView, eax

	mov	lvcolumn.imask, LVCF_FMT+LVCF_SUBITEM+LVCF_TEXT+LVCF_WIDTH
	mov	lvcolumn.fmt, LVCFMT_CENTER

	mov	esi, eax
	lea	edx, lvcolumn
	mov	ebx, LVM_INSERTCOLUMN
	mov	eax, 2
	mov	ecx, 3

b0:	push	edx
	push	eax
	push	ebx
	push	esi
	dec	eax
	dec	ecx
	jne	b0

	mov	ebx, SendMessage

	mov	lvcolumn.lx,128
	mov	lvcolumn.pszText, offset Col10
	call	ebx

	mov	lvcolumn.lx,80
	mov	lvcolumn.pszText, offset Col20
	call	ebx

	mov	lvcolumn.lx,100
	mov	lvcolumn.pszText, offset Col30
	call	ebx
	ret
RefreshListview	endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

ShowTheFunctionsName proc uses esi edi ebx hDlg:DWORD, ItemId:DWORD, pF:DWORD
	LOCAL temp[512]:BYTE, lvitem:LV_ITEM, hListView:DWORD
	LOCAL NumberOfNames:DWORD, Base:DWORD

	push	ItemId
	push	hDlg
	call	GetDlgItem
	mov	hListView, eax

	mov	edi, pF
	add	edi, [edi+03Ch]
	assume	edi: ptr IMAGE_NT_HEADERS
	mov	edi, [edi].OptionalHeader.DataDirectory.VirtualAddress
	.if edi==0
		invoke	MessageBox, hDlg, addr NoExportTable, addr CapStr, MB_OK+MB_ICONERROR
		xor	eax, eax
		ret		
	.endif
	.if _maped==1
		push	edi
		push	pF
		call	RVA2Offset
		or	eax, eax
		jne	@1
			invoke	MessageBox, hDlg, addr Msg102, addr CapStr, MB_OK+MB_ICONERROR
		xor	eax, eax
		ret
@1:		mov	edi, eax
	.endif
	add	edi, pF
	assume	edi: ptr IMAGE_EXPORT_DIRECTORY

	push	edi
	mov	eax, dword ptr [edi]
	test	eax, eax
	jne	@10

	lea	edi, FileName
	call	GetPathLastName
	mov	esi, eax
	jmp	@11
	
@10:	push	eax
	lea	esi, buffer
	push	256
	push	esi
	call	RtlZeroMemory
	push	esi
	call	lstrcpy

@11:	push	esi
	push	offset template3
	push	edi
	call	@wsprintf1

	pop	edi

	push	[edi].NumberOfNames
	pop	NumberOfNames
	push	[edi].nBase 
	pop	Base 

	mov	esi, [edi].AddressOfNames
	.if _maped==1
		push	esi
		push	pF
		call	RVA2Offset
		or	eax, eax
		jne	@2
			invoke	MessageBox, hDlg, addr Msg102, addr CapStr, MB_OK+MB_ICONERROR
		xor	eax, eax
		ret
@2:		mov	esi, eax
	.endif
	add	esi, pF
	mov	ebx, [edi].AddressOfNameOrdinals
	.if _maped==1
		push	ebx
		push	pF
		call	RVA2Offset
		or	eax, eax
		jne	@3
			invoke	MessageBox, hDlg, addr Msg102, addr CapStr, MB_OK+MB_ICONERROR
		xor	eax, eax
		ret
@3:		mov	ebx, eax
	.endif
	add	ebx, pF

	mov	edi, [edi].AddressOfFunctions
	assume	edi: nothing
	.if _maped==1
		push	edi
		push	pF
		call	RVA2Offset
		or	eax, eax
		jne	@4
			invoke	MessageBox, hDlg, addr Msg102, addr CapStr, MB_OK+MB_ICONERROR
		xor	eax, eax
		ret
@4:		mov	edi, eax
	.endif
	add	edi, pF
	mov	lvitem.imask, LVIF_TEXT
	mov	lvitem.iItem, 0
; ------------------------------
; Agregar elementos al control
; -----------------------------
	.while NumberOfNames>0				
	; ---------------------------------
	; Ageregar el nombre de la funcin
	; ---------------------------------
		mov	lvitem.iSubItem, 0 
		; -----------------------------
		; Obtener un puntero al nombre
		; -----------------------------
		mov	eax, dword ptr [esi]
	.if _maped==1
		push	eax
		push	pF
		call	RVA2Offset
		or	eax, eax
		jne	@5
			invoke	MessageBox, hDlg, addr Msg102, addr CapStr, MB_OK+MB_ICONERROR
		xor	eax, eax
		ret

	.endif
@5:		add	eax, pF
		mov	lvitem.pszText, eax
		; ------------------------------------------
		; Obtener el tamao de la cadena del nombre
		; ------------------------------------------
		push	eax
		call	GetStrLen
		inc	eax
		mov	lvitem.cchTextMax, eax
	; ------------------------
	; Insertar primer elemento
	; ------------------------
		; ----------------------------------
		; Desplegar el nombre de la funcin
		; ----------------------------------
		lea	eax, lvitem
		push	eax
		push	0
		push	LVM_INSERTITEM
		push	hListView
		call	SendMessage
		; ------------------------------
		; Insertar siguientes elementos
		; ------------------------------
		xor	edx, edx
		mov	dx, [ebx]
		mov	ecx, edx
		add	ecx, Base
		shl	edx, 2
		add	edx, edi

		mov	eax, dword ptr [edx]
		push	eax

		lea	eax, temp
		mov	lvitem.pszText, eax
		mov	lvitem.cchTextMax, 2
		inc	lvitem.iSubItem
		invoke  wsprintf, eax, addr template1, ecx
		lea	eax, lvitem
		push	eax
		push	0
		push	LVM_SETITEM
		push	hListView
		call	SendMessage

		mov	lvitem.cchTextMax, 9
		inc	lvitem.iSubItem
		lea	eax, temp
		pop	ecx
		invoke  wsprintf, eax, addr template2, ecx
		lea	eax, lvitem
		push	eax
		push	0
		push	LVM_SETITEM
		push	hListView
		call	SendMessage

		dec	NumberOfNames
		add	esi, 4
		add	ebx, 2
		inc	lvitem.iItem
	.endw
	mov	eax, 1
	ret
ShowTheFunctionsName endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetStrLen proc pStr:DWORD
        push   edi
        mov    edi, pStr
        xor    ecx, ecx
        mov    eax, ecx
	dec    ecx
        repne  scasb
        neg    ecx
	dec    cl
        dec    cl
        mov    eax, ecx
	pop    edi
        ret
GetStrLen endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@wsprintf1	proc near
		push	ebp
		mov	ebp, esp
		sub	esp, 204h
		push	esi
		push	edi
		mov	esi, [ebp+0Ch]
		lea	edi, [ebp-200h]
		push	1FCh
		push	edi
		call	RtlZeroMemory
		push	esi
		call	GetStrLen
		mov	ecx, eax
		push	ecx
		rep movsb
		pop	ecx
		sub	edi, ecx
		mov	al, '%' 
		repne scasb
		or	ecx, ecx
		jz	get_out
		mov	esi, edi
		lodsb
		cmp	al, 's'
		jnz	get_out
		mov	esi, [ebp+10h]
		push	esi
		call	GetStrLen
		mov	ecx, eax
		dec	edi
		rep movsb
		push	edi
		mov	edi, [ebp+0Ch]
		xor	ecx, ecx
		dec	ecx
		mov	al, '%'
		repne scasb
		inc	edi
		push	edi
		call	GetStrLen
		mov	ecx, eax
		pop	esi
		xchg	edi, esi
		rep movsb
		mov	esi, [ebp+8]
		lea	edi, [ebp-200h]
		push	edi
		push	esi
		call	lstrcpy

get_out:	pop	edi
		pop	esi
		leave	
		retn	0Ch
@wsprintf1	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; ------------------------------------------------------------------
; GetPathLastName procedure
; 
;  Obtiene un puntero al ltimo nombre de la cadena de un camino
;
;  edi = pointer to path string
;  edi = puntero a la cadena del camino
; ------------------------------------------------------------------

GetPathLastName:
	push	esi
	mov	esi, edi
	lodsb
	cmp	al, '\'
	je	@p1_
	lodsb
	cmp	al, ':'
	je	@p0_
	pop	esi
	mov	eax, edi
	ret
@p0_:	dec	esi
@p1_:	dec	esi
	invoke	GetStrLen, esi
	add	esi, eax
	std
@p2_:	lodsb
	cmp	al, '\'
	jne	@p2_
	inc	esi
@p3_:	inc	esi
        mov	eax, esi
	cld
	pop	esi
	ret

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

OpenAndMapFile:
		mov	eax, [esp+4]
		call	OpenFileToRead
		inc	eax
		je	OpenAndMapFile_00
		dec	eax
		push	0
		push	eax
		call	MapFile
OpenAndMapFile_00:
		ret 4

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::		

OpenFileToReadWrite:
		mov	edx, GENERIC_READ or GENERIC_WRITE
		jmp	_Create
OpenFileToRead:
		mov	edx, GENERIC_READ
		jmp	_Create
OpenFileToWrite:
		mov	edx, GENERIC_WRITE
_Create:	xor	ecx, ecx
	      	push	ecx
              	push	FILE_ATTRIBUTE_NORMAL
              	push	OPEN_EXISTING
              	push	ecx
              	push	ecx
              	push	edx
              	push	eax
              	call	CreateFileA
		ret

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

MapFile:	push	esi
		mov	esi, [esp+8]
		push	ebx
		xor	ebx, ebx
		push	edi
		mov	edi, [esp+20]
@MapFile_00:   	push	ebx
              	push	edi
              	push	ebx
              	push	PAGE_READONLY
              	push	ebx
              	push	esi
              	Call	CreateFileMappingA
		or	eax, eax
		je	@MapFile_01
		push	eax
		push	eax

		push	esi
		call	CloseHandle

		pop	eax

		push	edi
		push	ebx
		push	ebx
		push	FILE_MAP_READ
		push	eax
		Call	MapViewOfFile
		mov	esi, eax

		Call	CloseHandle
		mov	eax, esi
@MapFile_01:	pop	edi
		pop	ebx
		pop	esi
		ret 8

; ======================================================================
;                          RVA2Offset procedure
; ======================================================================

RVA2Offset:   push ebp
              mov ebp, esp

              push esi
; ---------------------------
; Get the number of sections
; ---------------------------
              PEFHDROFFSET dword ptr [ebp+08h]         ; pFile
              movzx ecx, word ptr [eax+2]
; --------------------------------
; Get a pointer to sections header
; --------------------------------
              SECHDROFFSET [ebp+08h]
              mov esi, eax
m00:          
	; --------------------------------
	; Is the address in this section?
	; --------------------------------
              mov eax, dword ptr [esi+0Ch] ; rva
              cmp dword ptr [ebp+0Ch], eax
              jl  m02
              add eax, dword ptr [esi+10h] ; section_rva + sec_size
              cmp dword ptr [ebp+0Ch], eax
              jg  m01                      ; not: jump
; -----------------------------
; Get the correspondient offset
; -----------------------------
              mov eax, dword ptr [ebp+0Ch] ; rva
              sub eax, dword ptr [esi+0Ch] ; rva - section_rva = .offset
              add eax, dword ptr [esi+14h] ; .offset + raw_offset = offset
              jmp m03
; ------------------------
; Revise the next section
; ------------------------
m01:          add esi, 028h
              loop m00
; ----------------------------------------
; This address does not exist in this file
; ----------------------------------------
m02:          xor eax, eax
m03:          pop esi 
              leave
              ret 8

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

end	start

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
